<?php

//////////////////////////////////////////////////////////////
//===========================================================
// firewall_plans_theme.php
//===========================================================
// SOFTACULOUS VIRTUALIZOR
// Version : 2.8.1
// Inspired by the DESIRE to be the BEST OF ALL
// ----------------------------------------------------------
// Started by: Paramhans	
// Date:       1st Jan 2024
// Time:       00:00 hrs
// Site:       https://www.virtualizor.com/ (SOFTACULOUS VIRTUALIZOR)
// ----------------------------------------------------------
// Please Read the Terms of use at https://www.virtualizor.com
// ----------------------------------------------------------
//===========================================================
// (c)Softaculous Ltd.
//===========================================================
//////////////////////////////////////////////////////////////

if(!defined('VIRTUALIZOR')){

	die('Hacking Attempt');

}

function getSortHeader($header_name, $sort_column, $sort_column_by, $column ,$size = 80){

	global $theme, $globals;
	
	$str = '<div class="d-inline-flex align-items-center justify-content-center mx-3" style="width:'.$size.'px;">
				<span class="sorter">
					<a class="text-always-white" href="'.$globals['index'].'act=firewall_plans&sortcolumn='.$column.'&sortby=desc"><i class="fas fa-chevron-circle-down"></i></a>
				</span>
				<div class="mx-1 text-always-white">
					<span class="" >'.$header_name.'</span>
				</div>
				<span class="sorter">
					<a class="text-always-white" href="'.$globals['index'].'act=firewall_plans&sortcolumn='.$column.'&sortby=asc"><i class="fas fa-chevron-circle-up"></i></a>
				</span>
			</div>';
		
	return $str;
}

function firewall_plans_theme(){

global $theme, $globals, $kernel, $user, $l, $firewall_plans, $admin_users, $sort_column, $sort_column_by, $error, $done;

softheader($l['<title>']);

echo '
<div class="bg">
<div class="row my-3 mx-auto">
<div class="col-10">
<h4 class="text-dark"><i class="fas fa-fire-alt"></i> '.$l['firewall_plans_tit'].'</h4>
</div>
<div class="col-2 d-flex align-items-center justify-content-end">
<span class="search_btn icon-fix d-flex align-items-center justify-content-center ml-1" tooltip="'.$l['search'].'"><a href="javascript:showsearch();" class="text-light"><i class="fas fa-search"></i></a></span>
</div>
</div>
';

error_handle($error);

echo '<script language="javascript" type="text/javascript"><!-- // --><![CDATA[

	function go_click(ele) {
	
		var firewall_list = new Array();
		
		$(".ios:checked").each(function() {
			firewall_list.push($(this).val());
		});
		
		if(firewall_list.length < 1){
			showalert("'.$l['nothing_selected'].'","1");
			return false;
		}
		
		var action = $(ele).parent().prev().find("select").val();
		
		if(action == 1) {
			Delfirewall_plans(firewall_list);
		}else {
			showalert("'.$l['no_action'].'","1");
			return false;
		}
		
	}

function Delfirewall_plans(firewall_list){
	showalert("'.$l['del_conf'].'" ,"3" ,function(confirm){
		if(confirm == false){
			return false;
		}else{
			var finalData = new Object();
			finalData["delete"] = firewall_list.join(",");

			//alert(finalData);
			//return false;
			
			$("#progress_bar").show();
			
			$.ajax({
				type: "POST",
				url: "'.$globals['index'].'act=firewall_plans&api=json",
				data : finalData,
				dataType : "json",
				success: function(data){
					$("#progress_bar").hide();
					if("get_deletion_confirmation" in data){

						showalert(data["get_deletion_confirmation"], "3", function(confirm){

							if(confirm == false){
								return false;

							}else{
								
								finalData["confirm_delete"] = 1;
								$("#progress_bar").show();
								$.ajax({
									type: "POST",
									url: "'.$globals['index'].'act=firewall_plans&api=json",
									data : finalData,
									dataType : "json",
									success: function(data){

										$("#progress_bar").hide();
										if("done" in data){
											setTimeout(function(){showalert(data["done"]);
											$("#alert-modal").on("hidden.bs.modal", function (e) {
											location.reload(true);
											});} ,200);
										}
										
										if("error" in data){
											showalert(data["error"], 1);
										}
									},
								});
								
							}
						});
					}
					if("done" in data){
						setTimeout(function(){showalert(data["done"]);
						$("#alert-modal").on("hidden.bs.modal", function (e) {
						location.reload(true);
						});} ,200);
					}
				},
				error: function(data) {
					$("#progress_bar").hide();
					//alert(data.description);
					return false;
				}
			});
		}
	});
	
	return false;
};

// ]]></script>

<div id="showsearch" class="my-1" style="display:'.(optREQ('search') || (!empty($firewall_plans) && !empty($globals['showsearch'])) ? "" : "none").';">
	<form accept-charset="'.$globals['charset'].'" name="firewall_plans" method="GET" action="" class="form-horizontal">
		<input type="hidden" name="act" value="firewall_plans">	
		<div class="form-group_head">
			<div class="row mx-auto w-100">
				<div class="col-sm-4"></div>
				<div class="col-sm-4">
					<label>'.$l['fwp_name'].'</label>
					<input type="text" class="form-control" name="planname" id="planname" size="30" value="'.REQval('planname','').'"/>
				</div>
			</div>
		</div>
		<div class="row mx-auto w-100 my-2">
			<div class="col-sm-12 text-center mb-3">
				<button type="submit" name="search" class="go_btn mt-2" value="Search"/>'.$l['submit'].'</button>
			</div>
		</div>
	</form>
</div>';

if($done){
	show_alert($l['saved']);
	//echo '<div class="notice"><b>NOTE : </b> '..'</div><br />';
}
if(empty($firewall_plans)){
	optREQ('search') ? show_alert($l['no_res'], "2") : show_alert($l['no_plans'], "2");
	echo '<div class="notice"><b>NOTE : </b> '.(optREQ('search') ? $l['no_res'] : $l['no_plans']).'</div>';
}else{

echo'<div class="row mx-auto w-100 mt-3">
	<div class="col-sm-8 col-lg-8 col-md-6 mb-3 p-0">';
		page_links($globals['num_res'], $globals['cur_page'], $globals['reslen']);
	echo'
	</div>
	<div class="col-sm-4 col-lg-4 col-md-6 text-right mb-3 px-4">
		<div class="bottom-menu float-right w-100">
            <div class="row my-auto">
                <div class="p-0">
                    <label>'.$l['with_selected'].'</label>
                </div>
                <div class="col p-0">
					<select class="custom-select" name="firewall_task_select" id="firewall_task_select">
						<option value="0">---</option>
						<option value="1">'.$l['ms_delete'].'</option>
					</select>
                </div>
                <div class="pl-2">
					<input type="submit" id ="firewall_submit" class="go_btn" name="firewall_submit" value="'.$l['go'].'" onclick="go_click(this); return false;">
                </div>
            </div>
		</div>
	</div>
</div>
<form accept-charset="'.$globals['charset'].'" name="multi_dns" id="multi_dns" method="post" action="" class="form-horizontal">
<div class="w-100 mx-auto sticky">
'.get_num_records($globals['num_res']).'
<table class="table table-hover tablesorter">
<tr>
	<th  align="left" class="min_width">'.getSortHeader($l['fwid'], $sort_column, $sort_column_by, 'fwid' ,30).'</th>
	<th align="center">'.getSortHeader($l['fwp_name'], $sort_column, $sort_column_by, 'fwp_name' ,120).'</th>
	<th align="center">'.$l['rules'].'</th>
	<th align="center">'.getSortHeader($l['default_policy'], $sort_column, $sort_column_by, 'default_policy' ,130).'</th>
	<th align="center">'.getSortHeader($l['user'], $sort_column, $sort_column_by, 'user', 60).'</th>
	<th align="center">'.getSortHeader($l['admin_default'], $sort_column, $sort_column_by, 'admin_default', 130).'</th>
	<th align="center" colspan="2" class="min_width">'.$l['manage'].'</th>
	<th class="min_width z-index-1" align="center">
		'.get_checkbox('select_all', $l['checkall'], 'select_all', array('chk_it' => 0), '', 'select_all').'
	</th>
</tr>';
$i = 0;
foreach($firewall_plans as $k => $v){
	
	$data = json_decode($v['data'], true);

	echo '<tr>
		<td align="center">'.$v['fwid'].'</td>
		<td>'.$v['fw_plan_name'].'</td>
		<td ><span class="info-text" ><i class="fas text-primary fa-info-circle" aria-hidden="true" tooltip="'.implode("<br>", json_decode($v['rules'], 1)).'"></i></span></td>
		<td>'.(empty($v['default_policy']) ? $l['drop'] : $l['accept']).'</td>
		<td>'.$admin_users[$v['uid']].'</td>
		<td>'.(!empty($v['admin_default']) ? $l['yes'] : $l['no']).'</td>
		<td align="center" width="10"><a href="?act=editfirewall_plan&fwid='.$v['fwid'].'" title="Edit"><i class="fas fa-edit text-warning"></i></a></td>	
		<td align="center" width="10"><a href="javascript:void(0);" onclick="return Delfirewall_plans(['.$k.']);" title="Delete"><i class="fas fa-trash text-danger"></i></td>
		<td width="20" valign="middle" align="center">
			'.get_checkbox('firewall_list[]', '', '', array('chk_it' => 0), $k).'
		</td>
	</tr>';
	$i++;	
}
echo '</table>
</div>';
echo'<div class="row mx-auto w-100 mt-3">
	<div class="col-sm-8 col-lg-8 col-md-6 mb-3 p-0">';
		page_links($globals['num_res'], $globals['cur_page'], $globals['reslen']);
	echo'
	</div>
	<div class="col-sm-4 col-lg-4 col-md-6 text-right mb-3 px-4">
		<div class="bottom-menu float-right w-100">
            <div class="row my-auto">
                <div class="p-0">
                    <label>'.$l['with_selected'].'</label>
                </div>
                <div class="col p-0">
					<select class="custom-select" name="firewall_task_select" id="firewall_task_select">
						<option value="0">---</option>
						<option value="1">'.$l['ms_delete'].'</option>
					</select>
                </div>
                <div class="pl-2">
					<input type="submit" id ="firewall_submit" class="go_btn" name="firewall_submit" value="'.$l['go'].'" onclick="go_click(this); return false;">
                </div>
            </div>
		</div>
	</div>
</div>

<div id="progress_bar" style="display:none;">
	<br />
	<center>
		<font id="progress_txt" size="4" color="#222222">'.$l['action_msg'].'</font>
	</center>
	<div class="my-2" align="center">
		<div class="progress w-50">
			<div class="progress-bar bg-primary progress-bar-striped progress-bar-animated w-100">
			</div>
		</div>
	</div>
	<center>
		'.$l['notify_msg'].'
	</center>
</div>';

}

echo '<center><a href="'.$globals['ind'].'act=addfirewall_plan" class="link_btn">'.$l['add_firewall_plan'].'</a>
</center></div><br>


';
softfooter();

}
?>