<?php

//////////////////////////////////////////////////////////////
//===========================================================
// admin_acl_theme.php
//===========================================================
// SOFTACULOUS VIRTUALIZOR
// Version : 2.2.5
// Inspired by the DESIRE to be the BEST OF ALL
// ----------------------------------------------------------
// Started by: Alons
// Date:       8th Mar 2010
// Time:       23:00 hrs
// Site:       https://www.virtualizor.com/ (SOFTACULOUS VIRTUALIZOR)
// ----------------------------------------------------------
// Please Read the Terms of use at https://www.virtualizor.com
// ----------------------------------------------------------
//===========================================================
// (c)Softaculous Ltd.
//===========================================================
//////////////////////////////////////////////////////////////

if(!defined('VIRTUALIZOR')){

	die('Hacking Attempt');

}

function edit_admin_acl_theme(){

global $theme, $globals, $cluster, $servers, $user, $l, $done, $error, $acls;
softheader($l['<title>']);

echo '<style>label{font-weight: normal;padding-top: 1px;}</style>
<div class="bg">
<div class="row my-3 mx-auto">
<div class="col-10">
<h4 class="text-dark"><i class="fas fa-users"></i> '.$l['header'].'</h4>
</div>
<div class="col-2 text-right d-flex align-items-center justify-content-end">
<span class="icon-fix d-flex align-items-center justify-content-center"><a href="'.$globals['docs'].'administrator-acl/" target="_blank" tooltip="'.$l['wiki_help'].'"><i class="fas fa-question text-always-white" ></i></a></span>
</div>
</div>'.get_breadcrumb([
	['act' => 'admin_acl'],
	['act' => 'edit_admin_acl']
]);

error_handle($error);

if(!is_allowed('edit_admin_acl')){
	softfooter();
	return;
}

if(!empty($done)){
	show_alert($l['done']);
	echo '<div class="notice"><b>NOTE : </b>  &nbsp; '.$l['done'].'</div>';
}

echo '<script language="javascript" type="text/javascript"><!-- // --><![CDATA[

$(document).ready(function(){
	$(document).find(":checkbox").each(function(index, element){		
		if(element.checked){
			 $(this).parent().parent().parent().parent().parent().parent().show();	
		}
	});
});

function toggle_div(id){
	if ($("#"+id).is(":hidden")){
		$("#"+id).slideDown("slow");
		$("#"+id+"-label").html("-");
	}else{
		$("#"+id).slideUp("slow");
		$("#"+id+"-label").html("+");
	}
}

function plus_onmouseover(id){
	$("#"+id).attr("src", "'.$theme['images'].'admin/plus_hover.gif");
}

function plus_onmouseout(id){
$("#"+id).attr("src", "'.$theme['images'].'admin/plus.gif");
}

// ]]></script>
<style>
.togglediv{
	padding:8px 0px 0px 8px;
}

label{
	vertical-align: super;
  	padding-left: 8px;
}
</style>
<div class="card m-2 p-3">
<form accept-charset="'.$globals['charset'].'" name="edit_admin_acl" method="post" action="" class="form-horizontal">

<div class="row mx-auto w-100 my-3">
		<div class="col-sm-1">
			<label class="control-label p-0 mt-1">Name</label></div>
		<div class="col-sm-6 pull-left">
			<input type="text" class="form-control w-50" name="name" id="name" size="30" value="'.POSTval('name', $acls['acl_name']).'"/></div>
	</div>
<div class="row mx-auto w-100 my-3">
	<div class="col-sm-12">
		'.get_checkbox('select_all', $l['checkall'], 'select_all', array('chk_it' => 0), '', 'select_all').'
	</div>
</div>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'admindash\');"><span id="admindash-label">-</span>&nbsp;'.$l['cat_admin_dash'].'</div>
	<div id="admindash" class="togglediv w-100">
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_cluster_statistics', $l['cluster_statistics'], '', array('chk_it' => 1, 'val' => $acls['act_cluster_statistics'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_server_statistics', $l['server_statistics'], '', array('chk_it' => 1, 'val' => $acls['act_server_statistics'])).'
			</div>
		</div>
	</div>
</div>
<br/>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'vs\');"><span id="vs-label">-</span>&nbsp;'.$l['cat_vs'].'</div>
	<div id="vs" class="togglediv w-100">
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_vs', $l['listvs'], '', array('chk_it' => 1, 'val' => $acls['act_vs'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_vsresources', $l['vsresources'], '', array('chk_it' => 1, 'val' => $acls['act_vsresources'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_addvs', $l['addvs'], '', array('chk_it' => 1, 'val' => $acls['act_addvs'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_rebuildvs', $l['rebuildvs'], '', array('chk_it' => 1, 'val' => $acls['act_rebuildvs'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_editvs', $l['editvs'], '', array('chk_it' => 1, 'val' => $acls['act_editvs'])).'
			</div>		
			<div class="col-sm-3">
				'.get_checkbox('act_deletevs', $l['deletevs'], '', array('chk_it' => 1, 'val' => $acls['act_deletevs'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_suspendvs', $l['suspendvs'], '', array('chk_it' => 1, 'val' => $acls['act_suspendvs'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_unsuspendvs', $l['unsuspendvs'], '', array('chk_it' => 1, 'val' => $acls['act_unsuspendvs'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_vnc', $l['vsvnc'], '', array('chk_it' => 1, 'val' => $acls['act_vnc'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_migrate', $l['migrate'], '', array('chk_it' => 1, 'val' => $acls['act_migrate'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_ha', $l['ha'], '', array('chk_it' => 1, 'val' => $acls['act_ha'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_load_balancer', $l['act_load_balancer'], '', array('chk_it' => 1, 'val' => $acls['act_load_balancer'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_manage_load_balancer', $l['act_manage_load_balancer'], '', array('chk_it' => 1, 'val' => $acls['act_manage_load_balancer'])).'
			</div>
		</div>
	</div>
</div>
<br/>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'ippool\');"><span id="ippool-label">-</span>&nbsp;'.$l['cat_ippools'].'</div>
	<div id="ippool" class="togglediv w-100">
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_ippool', $l['ippools'], '', array('chk_it' => 1, 'val' => $acls['act_ippool'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_addippool', $l['addippool'], '', array('chk_it' => 1, 'val' => $acls['act_addippool'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_editippool', $l['editippool'], '', array('chk_it' => 1, 'val' => $acls['act_editippool'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deleteippool', $l['deleteippool'], '', array('chk_it' => 1, 'val' => $acls['act_deleteippool'])).'
			</div>		
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_ips', $l['ips'], '', array('chk_it' => 1, 'val' => $acls['act_ips'])).'
			</div>		
			<div class="col-sm-3">
				'.get_checkbox('act_addips', $l['addips'], '', array('chk_it' => 1, 'val' => $acls['act_addips'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_editips', $l['editips'], '', array('chk_it' => 1, 'val' => $acls['act_editips'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deleteips', $l['deleteips'], '', array('chk_it' => 1, 'val' => $acls['act_deleteips'])).'
			</div>
		</div>
		<br/>
	</div>
</div>
<br/>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'servers\');"><span id="servers-label">-</span>&nbsp;'.$l['cat_servers'].'</div>
	<div id=servers class="togglediv w-100">
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_servers', $l['servers'], '', array('chk_it' => 1, 'val' => $acls['act_servers'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_addserver', $l['addserver'], '', array('chk_it' => 1, 'val' => $acls['act_addserver'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_editserver', $l['editserver'], '', array('chk_it' => 1, 'val' => $acls['act_editserver'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deleteserver', $l['deleteserver'], '', array('chk_it' => 1, 'val' => $acls['act_deleteserver'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_sg', $l['sg'], '', array('chk_it' => 1, 'val' => $acls['act_sg'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_addsg', $l['addsg'], '', array('chk_it' => 1, 'val' => $acls['act_addsg'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_editsg', $l['editsg'], '', array('chk_it' => 1, 'val' => $acls['act_editsg'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deletesg', $l['deletesg'], 'act_deletesg', array('chk_it' => 1, 'val' => $acls['act_deletesg'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_manageserver', $l['manageserver'], '', array('chk_it' => 1, 'val' => $acls['act_manageserver'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_rebootserver', $l['reboot'], '', array('chk_it' => 1, 'val' => $acls['act_rebootserver'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_terminal', $l['terminal'], '', array('chk_it' => 1, 'val' => $acls['act_terminal'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_sso', $l['sso'], '', array('chk_it' => 1, 'val' => $acls['act_sso'])).'
			</div>
		</div>
	</div>
</div>
<br/>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'storage\');"><span id="storage-label">-</span>&nbsp;'.$l['cat_storage'].'</div>
	<div id="storage" class="togglediv w-100">
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_storage', $l['storage'], '', array('chk_it' => 1, 'val' => $acls['act_storage'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_addstorage', $l['addstorage'], '', array('chk_it' => 1, 'val' => $acls['act_addstorage'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_editstorage', $l['editstorage'], '', array('chk_it' => 1, 'val' => $acls['act_editstorage'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deletestorage', $l['deletestorage'], '', array('chk_it' => 1, 'val' => $acls['act_deletestorage'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_volumes', $l['volumes'], '', array('chk_it' => 1, 'val' => $acls['act_volumes'])).'
			</div>
		</div>
	</div>
</div>
<br/>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'backups\');"><span id="backups-label">-</span>&nbsp;'.$l['cat_backups'].'</div>
	<div id="backups" class="togglediv w-100">
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_databackup', $l['backups'], '', array('chk_it' => 1, 'val' => $acls['act_databackup'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_performdatabackup', $l['perf_db_backups'], '', array('chk_it' => 1, 'val' => $acls['act_performdatabackup'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_dldatabackup', $l['dl_db_bakcups'], '', array('chk_it' => 1, 'val' => $acls['act_dldatabackup'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deletedatabackup', $l['del_db_backups'], '', array('chk_it' => 1, 'val' => $acls['act_deletedatabackup'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">		
			<div class="col-sm-3">
				'.get_checkbox('act_vpsbackupsettings', $l['edit_vps_backups'], '', array('chk_it' => 1, 'val' => $acls['act_vpsbackupsettings'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_vpsbackups', $l['vps_backups'], '', array('chk_it' => 1, 'val' => $acls['act_vpsbackups'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_restorevpsbackup', $l['restore_vs_backups'], '', array('chk_it' => 1, 'val' => $acls['act_restorevpsbackup'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deletevpsbackup', $l['delete_vs_backups'], '', array('chk_it' => 1, 'val' => $acls['act_deletevpsbackup'])).'
			</div>		
		</div>
		<div class="row mx-auto w-100 my-3">		
			<div class="col-sm-3">
				'.get_checkbox('act_backupservers', $l['list_backupservers'], '', array('chk_it' => 1, 'val' => $acls['act_backupservers'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_addbackupserver', $l['add_backupserver'], '', array('chk_it' => 1, 'val' => $acls['act_addbackupserver'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_editbackupservsers', $l['edit_backupserver'], '', array('chk_it' => 1, 'val' => $acls['act_editbackupservsers'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deletebackupserver', $l['delete_backupserver'], '', array('chk_it' => 1, 'val' => $acls['act_deletebackupserver'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">		
			<div class="col-sm-3">
				'.get_checkbox('act_backup_plans', $l['list_backup_plans'], '', array('chk_it' => 1, 'val' => $acls['act_backup_plans'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_addbackup_plan', $l['addbackup_plan'], '', array('chk_it' => 1, 'val' => $acls['act_addbackup_plan'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_editbackup_plan', $l['editbackup_plan'], '', array('chk_it' => 1, 'val' => $acls['act_editbackup_plan'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deletebackup_plan', $l['deletebackup_plan'], '', array('chk_it' => 1, 'val' => $acls['act_deletebackup_plan'])).'
			</div>
		</div>
	</div>
</div>
<br/>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'plans\');"><span id="plans-label">-</span>&nbsp;'.$l['cat_plans'].'</div>
	<div id="plans" class="togglediv w-100">
		<div class="row mx-auto w-100 my-3">		
			<div class="col-sm-3">
				'.get_checkbox('act_plans', $l['plans'], '', array('chk_it' => 1, 'val' => $acls['act_plans'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_addplan', $l['addplan'], '', array('chk_it' => 1, 'val' => $acls['act_addplan'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_editplan', $l['editplan'], '', array('chk_it' => 1, 'val' => $acls['act_editplan'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deleteplan', $l['deleteplan'], '', array('chk_it' => 1, 'val' => $acls['act_deleteplan'])).'
			</div>		
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_dnsplans', $l['dnsplans'], '', array('chk_it' => 1, 'val' => $acls['act_dnsplans'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_adddnsplan', $l['adddnsplan'], '', array('chk_it' => 1, 'val' => $acls['act_adddnsplan'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_editdnsplan', $l['editdnsplan'], '', array('chk_it' => 1, 'val' => $acls['act_editdnsplan'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deletednsplan', $l['deletednsplan'], 'act_deletednsplan', array('chk_it' => 1, 'val' => $acls['act_deletednsplan'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
			'.get_checkbox('act_add_dnsrecord', $l['add_dnsrecord'], '', array('chk_it' => 1, 'val' => $acls['act_add_dnsrecord'])).'
		</div>
		</div>
	</div>
</div>
<br/>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'users\');"><span id="users-label">-</span>&nbsp;'.$l['cat_users'].'</div>
	<div id="users"  class="toggledi w-100v">
		<div class="row mx-auto w-100 my-3">		
			<div class="col-sm-3">
				'.get_checkbox('act_users', $l['users'], '', array('chk_it' => 1, 'val' => $acls['act_users'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_adduser', $l['adduser'], '', array('chk_it' => 1, 'val' => $acls['act_adduser'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_edituser', $l['edituser'], '', array('chk_it' => 1, 'val' => $acls['act_edituser'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deleteuser', $l['deleteuser'], '', array('chk_it' => 1, 'val' => $acls['act_deleteuser'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_suspend_user', $l['suspend_user'], '', array('chk_it' => 1, 'val' => $acls['act_suspend_user'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_unsuspend_user', $l['unsuspend_user'], '', array('chk_it' => 1, 'val' => $acls['act_unsuspend_user'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_list_api', $l['list_api'], '', array('chk_it' => 1, 'val' => $acls['act_list_api'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_create_api', $l['create_api'], '', array('chk_it' => 1, 'val' => $acls['act_create_api'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_api_credential_edit', $l['api_credential_edit'], '', array('chk_it' => 1, 'val' => $acls['act_api_credential_edit'])).'
			</div>
		</div>
	</div>
</div>
<br/>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'media\');"><span id="media-label">-</span>&nbsp;'.$l['cat_media'].'</div>
	<div id="media" class="togglediv w-100">
		<div class="row mx-auto w-100 my-3">		
			<div class="col-sm-3">
				'.get_checkbox('act_ostemplates', $l['templates'], '', array('chk_it' => 1, 'val' => $acls['act_ostemplates'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_os', $l['templatebrowser'], '', array('chk_it' => 1, 'val' => $acls['act_os'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_addtemplate', $l['addtemplates'], '', array('chk_it' => 1, 'val' => $acls['act_addtemplate'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_edittemplate', $l['edittemplates'], '', array('chk_it' => 1, 'val' => $acls['act_edittemplate'])).'
			</div>		
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_deletetemplate', $l['deltetemplates'], '', array('chk_it' => 1, 'val' => $acls['act_deletetemplate'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_createtemplate', $l['createtemplate'], '', array('chk_it' => 1, 'val' => $acls['act_createtemplate'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_iso', $l['isos'], '', array('chk_it' => 1, 'val' => $acls['act_iso'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_addiso', $l['addiso'], '', array('chk_it' => 1, 'val' => $acls['act_addiso'])).'
			</div>	
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_editiso', $l['editisos'], '', array('chk_it' => 1, 'val' => $acls['act_editiso'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deleteiso', $l['deleteiso'], '', array('chk_it' => 1, 'val' => $acls['act_deleteiso'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_mg', $l['mgs'], '', array('chk_it' => 1, 'val' => $acls['act_mg'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_addmg', $l['addmgs'], '', array('chk_it' => 1, 'val' => $acls['act_addmg'])).'
			</div>		
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_editmg', $l['editmg'], '', array('chk_it' => 1, 'val' => $acls['act_editmg'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deletemg', $l['deletemgs'], '', array('chk_it' => 1, 'val' => $acls['act_deletemg'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_list_distros', $l['list_distros'], '', array('chk_it' => 1, 'val' => $acls['act_list_distros'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_add_distro', $l['add_distro'], '', array('chk_it' => 1, 'val' => $acls['act_add_distro'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_euiso', $l['euiso'], '', array('chk_it' => 1, 'val' => $acls['act_euiso'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_synciso', $l['sync_iso'], '', array('chk_it' => 1, 'val' => $acls['act_synciso'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_syncostemplate', $l['syncostemplate'], '', array('chk_it' => 1, 'val' => $acls['act_syncostemplate'])).'
			</div>
		</div>
	</div>
</div>
<br/>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'recipe_div\');"><span id="recipe_div-label">-</span>&nbsp;'.$l['cat_recipe'].'</div>
	<div id="recipe_div" class="togglediv w-100">
		<div class="row mx-auto w-100 my-3">		
			<div class="col-sm-3">
				'.get_checkbox('act_recipes', $l['recipes'], '', array('chk_it' => 1, 'val' => $acls['act_recipes'])).'
			</div>		
			<div class="col-sm-3">
				'.get_checkbox('act_addrecipe', $l['addrecipe'], '', array('chk_it' => 1, 'val' => $acls['act_addrecipe'])).'
			</div>		
			<div class="col-sm-3">
				'.get_checkbox('act_editrecipe', $l['editrecipe'], '', array('chk_it' => 1, 'val' => $acls['act_editrecipe'])).'
			</div>
		</div>
	</div>
</div>
<br/>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'config\');"><span id="config-label">-</span>&nbsp;'.$l['cat_config'].'</div>
	<div id="config"  class="toggledi w-100v">
		<div class="row mx-auto w-100 my-3">		
			<div class="col-sm-3">
				'.get_checkbox('act_config', $l['edit_settings'], '', array('chk_it' => 1, 'val' => $acls['act_config'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_emailsettings', $l['edit_emailsettings'], '', array('chk_it' => 1, 'val' => $acls['act_emailsettings'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_adminacl', $l['admin_acl'], '', array('chk_it' => 1, 'val' => $acls['act_adminacl'])).'
			</div>		
			<div class="col-sm-3">
				'.get_checkbox('act_add_admin_acl', $l['add_admin_acl'], '', array('chk_it' => 1, 'val' => $acls	['act_add_admin_acl'])).'
			</div>		
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_edit_admin_acl', $l['edit_admin_acl'], '', array('chk_it' => 1, 'val' => $acls['act_edit_admin_acl'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_delete_admin_acl', $l['delete_admin_acl'], '', array('chk_it' => 1, 'val' => $acls['act_delete_admin_acl'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_serverinfo', $l['serverinfo'], '', array('chk_it' => 1, 'val' => $acls['act_serverinfo'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_licenseinfo', $l['licenseinfo'], '', array('chk_it' => 1, 'val' => $acls['act_licenseinfo'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_hostname', $l['hostname'], '', array('chk_it' => 1, 'val' => $acls['act_hostname'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_changehostname', $l['edithostname'], '', array('chk_it' => 1, 'val' => $acls['act_changehostname'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_maintenance', $l['maintenance'], '', array('chk_it' => 1, 'val' => $acls['act_maintenance'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_kernconfig', $l['kern_config'], '', array('chk_it' => 1, 'val' => $acls['act_kernconfig'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_updates', $l['updates'], '', array('chk_it' => 1, 'val' => $acls['act_updates'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_emailtemps', $l['email_temps'], '', array('chk_it' => 1, 'val' => $acls['act_emailtemps'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_editemailtemps', $l['edit_email_temps'], '', array('chk_it' => 1, 'val' => $acls['act_editemailtemps'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_ssl', $l['ssl'], '', array('chk_it' => 1, 'val' => $acls['act_ssl'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_editssl', $l['editssl'], '', array('chk_it' => 1, 'val' => $acls['act_editssl'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_createssl', $l['createssl'], '', array('chk_it' => 1, 'val' => $acls['act_createssl'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_firewall', $l['firewall'], '', array('chk_it' => 1, 'val' => $acls['act_firewall'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_importvs', $l['importvs'], '', array('chk_it' => 1, 'val' => $acls['act_importvs'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_phpmyadmin', $l['pma'], '', array('chk_it' => 1, 'val' => $acls['act_phpmyadmin'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_ssh', $l['ssh'], '', array('chk_it' => 1, 'val' => $acls['act_ssh'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_defaultvsconf', $l['dif_vps_config'], '', array('chk_it' => 1, 'val' => $acls['act_defaultvsconf'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_multivirt', $l['multivirt'], '', array('chk_it' => 1, 'val' => $acls['act_multivirt'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_twofactauth', $l['twofactauth'], '', array('chk_it' => 1, 'val' => $acls['act_twofactauth'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_orphaneddisk', $l['orphaneddisk'], '', array('chk_it' => 1, 'val' => $acls['act_orphaneddisk'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deleteorphaneddisk', $l['deleteorphaneddisk'], '', array('chk_it' => 1, 'val' => $acls['act_deleteorphaneddisk'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_webuzo', $l['webuzo'], '', array('chk_it' => 1, 'val' => $acls['act_webuzo'])).'
			</div>
		</div>
	</div>
</div>
<br/>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'pdns\');"><span id="pdns-label">-</span>&nbsp;'.$l['cat_pdns'].'</div>
	<div id="pdns" class="togglediv w-100">
		<div class="row mx-auto w-100 my-3">		
			<div class="col-sm-3">
				'.get_checkbox('act_pdns', $l['pdns'], '', array('chk_it' => 1, 'val' => $acls['act_pdns'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_managepdns', $l['manage_pdns'], '', array('chk_it' => 1, 'val' => $acls['act_managepdns'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_addpdns', $l['add_pdns'], '', array('chk_it' => 1, 'val' => $acls['act_addpdns'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_editpdns', $l['edit_pdns'], '', array('chk_it' => 1, 'val' => $acls['act_editpdns'])).'
			</div>		
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_deletepdns', $l['delete_pdns'], '', array('chk_it' => 1, 'val' => $acls['act_deletepdns'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_rdns', $l['rdns'], '', array('chk_it' => 1, 'val' => $acls['act_rdns'])).'
			</div>
		</div>
	</div>
</div>
<br/>
<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'billing\');"><span id="billing-label">-</span>&nbsp;Billing</div>
	<div id="billing" class="togglediv w-100">
		<div class="row mx-auto w-100 my-3">		
			<div class="col-sm-3">
				'.get_checkbox('act_billing', $l['billing_set'], '', array('chk_it' => 1, 'val' => $acls['act_billing'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_resource_pricing', $l['resource_billing'], '', array('chk_it' => 1, 'val' => $acls['act_resource_pricing'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_invoices', $l['invoices'], '', array('chk_it' => 1, 'val' => $acls['act_invoices'])).'
			</div>	
			<div class="col-sm-3">
				'.get_checkbox('act_transactions', $l['transaction'], '', array('chk_it' => 1, 'val' => $acls['act_transactions'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_addinvoice', $l['add_invoice'], '', array('chk_it' => 1, 'val' => $acls['act_addinvoice'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_addtransaction', $l['add_transaction'], '', array('chk_it' => 1, 'val' => $acls['act_addtransaction'])).'
			</div>
		</div>
	</div>
</div>
<br/>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'procs\');"><span id="procs-label">-</span>&nbsp;'.$l['cat_procs'].'</div>
	<div id="procs" class="togglediv w-100">
		<div class="row mx-auto w-100 my-3">		
			<div class="col-sm-3">
				'.get_checkbox('act_procs', $l['manage_procs'], '', array('chk_it' => 1, 'val' => $acls['act_procs'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_services', $l['manage_services'], '', array('chk_it' => 1, 'val' => $acls['act_services'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_webserver', $l['restart_web'], '', array('chk_it' => 1, 'val' => $acls['act_webserver'])).'
			</div>	
			<div class="col-sm-3">
				'.get_checkbox('act_network', $l['restart_net'], '', array('chk_it' => 1, 'val' => $acls['act_network'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_sendmail', $l['restart_mail'], '', array('chk_it' => 1, 'val' => $acls['act_sendmail'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_mysqld', $l['restart_mysql'], '', array('chk_it' => 1, 'val' => $acls['act_mysqld'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_iptables', $l['restart_iptables'], '', array('chk_it' => 1, 'val' => $acls['act_iptables'])).'
			</div>
		</div>
	</div>
</div>
<br/>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'logs\');"><span id="logs-label">-</span>&nbsp;'.$l['cat_logs'].'</div>
	<div id="logs" class="togglediv w-100"> 
		<div class="row mx-auto w-100 my-3">		
			<div class="col-sm-3">
				'.get_checkbox('act_logs', $l['logs'], '', array('chk_it' => 1, 'val' => $acls['act_logs'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deletelogs', $l['deletelogs'], '', array('chk_it' => 1, 'val' => $acls['act_deletelogs'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_userlogs', $l['userlog'], '', array('chk_it' => 1, 'val' => $acls['act_userlogs'])).'
			</div>	
			<div class="col-sm-3">
				'.get_checkbox('act_deleteuserlogs', $l['deleteuserlogs'], '', array('chk_it' => 1, 'val' => $acls['act_deleteuserlogs'])).'
			</div>			
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_loginlogs', $l['loginlogs'], '', array('chk_it' => 1, 'val' => $acls['act_loginlogs'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deleteloginlogs', $l['delteloginlogs'], '', array('chk_it' => 1, 'val' => $acls['act_deleteloginlogs'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_iplogs', $l['iplogs'], '', array('chk_it' => 1, 'val' => $acls['act_iplogs'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deliplogs', $l['deliplogs'], '', array('chk_it' => 1, 'val' => $acls['act_deliplogs'])).'
			</div>
		</div>
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_show_api_log', $l['show_api_log'], '', array('chk_it' => 1, 'val' => $acls['act_show_api_log'])).'
			</div>
		</div>
	</div>
</div>
<br/>

<div class="cat-wrapper">
	<div class="roundheader cursor-pointer" onclick="toggle_div(\'domain_frwd\');"><span id="domain_frwd-label">-</span>&nbsp;'.$l['cat_haproxy'].'</div>
	<div id="domain_frwd" class="togglediv w-100"> 
		<div class="row mx-auto w-100 my-3">		
			<div class="col-sm-3">
				'.get_checkbox('act_haproxy', $l['haproxy'], '', array('chk_it' => 1, 'val' => $acls['act_haproxy'])).'
			</div>
		</div>
	</div>
</div>
<br />

<div class="cat-wrapper">
	<div class="roundheader" onclick="toggle_div(\'passthrough_div\');"><span id="passthrough_div-label">-</span>&nbsp;'.$l['cat_passthrough'].'</div>
	<div id="passthrough_div"  class="togglediv w-100">
		<div class="row mx-auto w-100 my-3">
			<div class="col-sm-3">
				'.get_checkbox('act_passthrough', $l['passthrough'], '', array('chk_it' => 1, 'val' => $acls['act_passthrough'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_addpassthrough', $l['addpassthrough'], '', array('chk_it' => 1, 'val' => $acls['act_addpassthrough'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_editpassthrough', $l['editpassthrough'], '', array('chk_it' => 1, 'val' => $acls['act_editpassthrough'])).'
			</div>
			<div class="col-sm-3">
				'.get_checkbox('act_deletepassthrough', $l['deletepassthrough'], '', array('chk_it' => 1, 'val' => $acls['act_deletepassthrough'])).'
			</div>
		</div>
	</div>
</div>

<center><input type="submit" name="edit_admin_acl" value="'.$l['save'].'"  class="go_btn"></center>
</form>
<br />

</div></div>
';

softfooter();

}

?>