<?php

//////////////////////////////////////////////////////////////
//===========================================================
// haproxy.php
//===========================================================
// SOFTACULOUS VIRTUALIZOR
// Version : 1.0
// Inspired by the DESIRE to be the BEST OF ALL
// ----------------------------------------------------------
// Started by: Abhijeet
// Date:       10th Feb 2017
// Time:       16:30 hrs
// Site:       https://www.virtualizor.com/ (SOFTACULOUS VIRTUALIZOR)
// ----------------------------------------------------------
// Please Read the Terms of use at https://www.virtualizor.com
// ----------------------------------------------------------
//===========================================================
// (c)Softaculous Ltd.
//===========================================================
//////////////////////////////////////////////////////////////

if(!defined('VIRTUALIZOR')){

	die('Hacking Attempt');

}

function haproxy_theme(){

global $theme, $globals, $servergroups, $servers, $supported_protocols, $haproxydata, $vpses, $l, $error, $done, $server_haconfigs,$arr_haproxy_src_ips;

softheader($l['<haproxy>']);
echo '
<style>

</style>
';

echo '<link rel="stylesheet" type="text/css" href="'.$theme['url'].'/css2/jquery.dataTables.min.css">
<script type="text/javascript" charset="utf8" src="'.$theme['url'].'/js2/jquery.dataTables.min.js"></script>';

echo '
<script>';

// Parse and include haproxy.js file
echo parse_lang(file_get_contents($theme['url'].'/js/haproxy.js'));

echo '
	
	var $server_haconfigs = '.json_encode($server_haconfigs).';
	var $haproxydata = '.json_encode($haproxydata).';
	var $servers = '.json_encode($servers).';
	var $vpses = '.json_encode($vpses).';
	var $supported_protocols = '.json_encode($supported_protocols).';
	var $l = '.json_encode($l).';
	
	var $edit = null; 
	
	var is_admin = 1;
	vdf_edit_ico = "fas fa-edit";
	vdf_save_ico = "fas fa-save";
	vdf_delete_ico = "fas fa-delete";
	vdf_revert_ico = "fas fa-undo";
	arr_haproxy_src_ips = '.json_encode($arr_haproxy_src_ips).';
	
	var vdf_url = window.location.origin+window.location.pathname+"?act=haproxy&api=json&page='.(int) optREQ('page').'&reslen='.(int) optREQ('reslen').'"+(window.location.search.includes("debug=died") ? "&debug=died" : "");
	
	$(document).ready(function(){
		update_record_alerts();
	});
	
	function ajaxprocess(self, postdata, success, fail, showprocess){
		
		var url_path = window.location.origin+window.location.pathname+"?act=";
		
		//Show processing
		if(showprocess != undefined){
			var progressbar = "<div class=\"w-100 d-flex justify-content-center py-1\"><div class=\"loader\"></div></div>";
			var oldhtml = $(self).html();
			var oldclass = $(self).attr("class");
			$(self).html(progressbar);
		}
		
		$.ajax({
			type: "post",
			url: url_path+"haproxy&api=json"+(window.location.search.includes("debug=died") ? "&debug=died" : ""),
			data: postdata,
			dataType : "json",
			success: function (data){
				//Remove processing
				if(showprocess != undefined){
					$(self).html(oldhtml);
					$(self).attr("class", oldclass);
				}
				eval(success)(self, data);
				
			},
			error: function(data){
				//Remove processing
				if(showprocess != undefined){
					$(self).html(oldhtml);
					$(self).attr("class", oldclass);
				}
				
				var reg_pat = /could\snot\smake\sthe\squery/i;
				var alert_str = (reg_pat.test(data.responseText) == true ? $l["db_query_error"] : $l["err_unknown"]);
				showalert(alert_str,"1");
				eval(fail)(self, data);
			}
		});
	}
	
	// Script to Manage HAProxy Servers
	function showhaservers_page(){
		$("#showhaserversbtn").attr("id", "showvdfbtn");
		$("#showvdfbtn").attr("onclick", "showvdf_page()");
		$("#showvdfbtn").html($l["list_records"]);
		$("#vdf_search_link").hide();
		$("#showvdfformbtn").hide();
		$("#search_btn").hide();
		
		$("#domain_forwarders_div").hide();
		$("#haservers_div").show();
		show_ha_servers_tbl();
	}
	
	function showvdf_page(){
		$("#showvdfbtn").attr("id", "showhaserversbtn");
		$("#showhaserversbtn").attr("onclick", "showhaservers_page()");
		$("#showhaserversbtn").html("Servers");
		$("#vdf_search_link").show();
		$("#showvdfformbtn").show();
		$("#search_btn").show();
		
		$("#domain_forwarders_div").show();
		$("#haservers_div").hide();
		$("#haservers_div").html("");
		
	}
	$(document).ready(function(){
		var server_btn = "&nbsp;<button id=\"showhaserversbtn\" class=\"btn\" onclick=\"showhaservers_page()\" >"+$l["servers"]+"</button>";
		$("#showvdfformbtn").parent().append(server_btn);
	});
	
	function show_ha_servers_tbl(){
		$str = "";
		$str += "<div class=\"row w-100 mx-auto\"> \
			<div class=\"col-sm-12 p-0\">\
				<table class=\"table table-hover tablesorter\" id=\"ha_servers_tbl\">\
					<thead>\
						<tr>\
							<th style=\"width: 20px;\">'.$l['id'].'</th>\
							<th style=\"width: 350px;\">'.$l['serid'].'</th>\
							<th style=\"width: 50px;\">'.$l['enabled'].'</th>\
							<th style=\"width: 50px;\">'.$l['status'].'</th>\
							<th style=\"width: 150px;\">'.$l['actions'].'</th>\
						</tr>\
					</thead>\
					<tbody></tbody>\
					<tfoot></tfoot>\
				</table>\
			</div>\
		</div><br />"
		$("#haservers_div").html($str);
		
		ajaxprocess("", "server_page=1", populate_ha_servers_tbl, populate_ha_servers_tbl);
		
		$("#ha_servers_tbl").after("<div class=\"row w-100 wait_img\"><div class=\"col-sm-12 justify-content-center d-flex\"><div class=\"progress w-25\">\
			<div class=\"progress-bar bg-primary progress-bar-striped progress-bar-animated w-100\">\
			</div>\
		</div></div></div>");
	}
	
	function populate_ha_servers_tbl(self ,ajaxdata){
		
		if(ajaxdata != undefined && ajaxdata.servers != undefined){
			$servers = (!!ajaxdata.servers ? ajaxdata.servers : {});
		}
		
		$("#haservers_div .wait_img").remove();
		var strdata = "";
		$.each($servers, function(i,t){
			var status = "--";
			if(t["haproxy_status"] == "1"){
				status = $l["error_state"];
			}
			if(t["haproxy_status"] == "0"){
				status = $l["running"];
			}
			if(t["haproxy_status"] == "3"){
				status = $l["stopped"];
			}
			
			strdata += "\
			<tr>\
				<td class=\"text-center\">"+t["serid"]+"</td> \
				<td class=\"text-center\">"+t["server_name"]+"</td> \
				<td class=\"text-center\">"+(t["haproxy_enable"] ? $l["yes"] : $l["no"])+"</td> \
				<td class=\"text-center\">"+status+"</td> \
				<td class=\"text-right ha_servers_actions\" id=\""+t["serid"]+"_server_actions\">\
					<span ><button class=\"btn mr-2 mb-1\"  data-placement=\"auto\" tooltip=\""+$l["tooltip_update_server_src_ips"]+"\" onclick=\"show_update_server_src_ips_form(this);\" >"+$l["map_ips"]+"</button></span> \
					<span ><button class=\"go_btn mr-2 mb-1\"   data-placement=\"auto\" tooltip=\""+$l["tooltip_reload_haproxy_service"]+"\" onclick=\"reload_haproxy_service(this);\" >"+$l["service_reload"]+"</button></span> \
				</td> \
			</tr>\
			";
		});
		$("#ha_servers_tbl tbody").eq(0).html(strdata);
		show_tooltip();
	}
	
	function reload_haproxy_service(self, ajaxdata){
		var serid = $(self).parents().eq(1).attr("id").split("_")[0];
		
		if(ajaxdata == undefined){
			ajaxprocess(self, "server_page=1&reload=1&serid="+encodeURIComponent(serid), reload_haproxy_service, reload_haproxy_service, 1);
			return;
		}else{
			if(ajaxdata.done != undefined && ajaxdata.done.success != undefined){
				showalert($l["success_reload_ha_service"]);
				populate_ha_servers_tbl("", ajaxdata);
				
			}else if(ajaxdata.error != undefined){
				var str = "";
				$.each(ajaxdata.error, function(i,t){
					str += t+"\n";
				});
				showalert(($l["errors"]+":\n"+str), "1");
			}else{
				showalert($l["err_reload_ha_service"], "1");
			}
		}
	}
	function show_update_server_src_ips_form(self, ajaxdata){
		var serid = $(self).parents().eq(1).attr("id").split("_")[0];
		
		if(ajaxdata == undefined){
			ajaxprocess(self, "server_page=1&get_server_old_src_ips=1&serid="+encodeURIComponent(serid)+"", show_update_server_src_ips_form, show_update_server_src_ips_form, 1)
			return true;
		}else{
			if(ajaxdata.done != undefined){
				if(ajaxdata.server_old_src_ips == undefined || ajaxdata.server_old_src_ips.length == 0){
					showalert($l["err_no_old_src_ips"],"1");
					return;
				}
				$str = "<div class=\"w-100 p-0\" id=\"update_server_src_ips_form_div\">";
				$str += "<div class=\"row mx-auto w-100 h5\"><div class=\"col-sm-12\" ><span>"+$servers[serid]["server_name"]+"</span></div></div><hr />";
				$str += "<div class=\"row mx-auto w-100\"><div class=\"col-sm-6\"><span>"+$l["head_old_src_ips"]+"</span></div><div class=\"col-sm-6\"><span>"+$l["head_new_src_ips"]+"</span></div></div><hr />";
				$str += "<form id=\"update_server_src_ips_form\" name=\"update_server_src_ips_form\" action=\"\" onsubmit=\"return false;\" >";
				$.each(ajaxdata.server_old_src_ips[serid], function(i, t){
					$str += "<div class=\"row mx-auto w-100 form-group\"><div class=\"col-sm-6\"><label>"+t+"</label></div><div class=\"col-sm-6\"><select class=\"virt-select\" name=\"src_ips["+t+"]\">";
						$str += "<option value=\"-1\" >"+$l["vdf_select_ip"]+"</option>";
						$.each($servers[serid]["arr_haproxy_src_ips"], function(k, v){
							$str += "<option value=\""+v+"\" >"+v+"</option>";
						});
					$str += "</select></div></div>";
				});
				$str += "<input type=\"hidden\" name=\"serid\" value=\""+serid+"\" >";
				$str += "<div class=\"row mx-auto w-100\"><div class=\"col-sm-12 text-center\"><span onclick=\"update_server_src_ips(this)\" ><button class=\"btn btn-sm\" >"+$l["update"]+"</button></span></div></div>";
				$str += "<div>";
				$("#haproxymodal1 .modal-body").eq(0).html($str);
				$("#haproxymodal1").modal({show:true});		
				$(".virt-select").select2({width:"100%"});		
			}else if(ajaxdata.error != undefined){
				var str = "";
				$.each(ajaxdata.error, function(i,t){
					str += t+"\n";
				});
				showalert(($l["errors"]+":\n"+str),"1");
			}else{
				showalert($l["err_request"],"1");
				return false;
			}
		}
	}
	
	function update_server_src_ips(self, ajaxdata){
		
		if(ajaxdata == undefined){
			
			showalert($l["confirm_update_src_ips"] ,"3" ,function(confirm){
				if(confirm == false){
					return false;
				}else{
					var postdata = "";
					postdata += "server_page=1&update_server_src_ips=1&"+$("#update_server_src_ips_form").serialize();
			
					ajaxprocess(self, postdata, update_server_src_ips, update_server_src_ips, 1)
			
					return true;
				}
			});	
		}else{
			
			if(ajaxdata.done != undefined && ajaxdata.done.success != undefined){
				$haproxydata = (!!ajaxdata.haproxydata ? ajaxdata.haproxydata : {});
				showalert($l["vdf_success_update"]);
				$("#haproxymodal1").modal("hide");
				
			}else if(ajaxdata.error != undefined){
				
				var str = "";
				$.each(ajaxdata.error, function(i,t){
					str += t+"\n";
				});
				
				showalert(($l["errors"]+":\n"+str),"1");
				
			}else{
				
				showalert($l["err_request"],"1");
				
				return false;
			}
		}
	}
</script>

<!-- Update server\'s source IPs form modal -->
<div class="modal fade" id="haproxymodal1">
	<div class="modal-dialog">
		<div class="modal-content">
			<div class="modal-header d-flex align-items-center">
				<h6>'.$l["heading_update_old_src_ips"].'</h6>
				<button type="button" class="close text-always-white" data-dismiss="modal">×</button>
			</div>
			<div class="modal-body"></div>
		</div>
	</div>
</div>
<div class="bg">
<div class="row my-3 mx-auto">
	<div class="col-10">
		<h4 class="text-dark"><i class="icon icon-firewall2 h4 m-0"></i> '.$l['<title>'].'</h4>
	</div>
	<div class="col-2 d-flex align-items-center justify-content-end text-right">
		<span class="icon-fix d-flex align-items-center justify-content-center mr-2">
			<a href="javascript:void(0)" onclick="$(\'#vdf_infobox\').slideToggle();"><i class="fas fa-info"></i></a>
		</span>
		<span class="icon-fix d-flex align-items-center justify-content-center mr-2">
			<a href="'.$globals['docs'].'Manage_VPS_Domain_Forwarding" target="_blank" tooltip="'.$l['wiki_help'].'"><i class="fas fa-question"></i></a>
		</span>
		<span class="icon-fix d-flex align-items-center justify-content-center">
			<a href="javascript:showsearch();" class="search_btn py-1 text-light" id="search_btn"><i class="fas fa-search"></i></a>
		</span>
	</div>
</div>';
echo '
<div id="vdf_infobox" class="mt-3" style="display:none;">
	<div class="heading">'.$l['vdf_info'].'</div>
	<div class="body">
		<div class="scrollbar-virt">
			<div>';
			foreach($server_haconfigs as $k => $v){
				echo '<div>
					<b>'.$l['vdf_info_server'].':</b> '.$servers[$k]["server_name"].'<br/>
					<b>'.$l['vdf_info_reservedports'].':</b> '.$v["haproxy_reservedports"].'<br/>
					<b>'.$l['vdf_info_reservedports_http'].':</b> '.$v["haproxy_reservedports_http"].'<br/>
					<b>'.$l['vdf_info_allowedports'].':</b> '.$v["haproxy_allowedports"].'<br/>
					</div><br/>
				';
			}
		echo '</div>
		</div>
	</div>
</div>';
//-------------- Search VDF Block Starts ---------------------
echo '<div id="showsearch" style="display:'.(optREQ('haproxysearch') || (!empty($haproxydata) && !empty($globals['showsearch'])) ? "" : "none").';" class="mb-3">
<form accept-charset="'.$globals ['charset'].'" name="haproxysearchform" method="get" action="" id="haproxysearchform" class="form-horizontal">
<input type="hidden" name="act" value="haproxy">
<div class="form-group_head">
	<div class="row mx-auto w-100">
	    <div class="col-sm-3">
			<div class="col-xs-12"><label>'.$l['id'].'</label></div>
			<div class="col-xs-12"><input class="form-control" type="text" name="s_id" id="s_id" size="15" value="'.REQval('s_id','').'"/></div>
		</div>
		<div class="col-sm-3">
			<div class="col-xs-12"><label>'.$l['vdf_serid'].'</label></div>
			<div class="col-xs-12 server-select-lg">
				<select name="s_serid" id="s_serid" class="form-control virt-select">
					<option value="-1" '.(REQval('s_serid') == - 1 ? 'selected="selected"' : '').'>'.$l['select_server'].'</option>';
					foreach($servers as $key => $id) {
						echo '<option value="'.$key.'" '.(isset($_REQUEST ['s_serid']) && REQval('s_serid') == $key ? 'selected="selected"' : '').'>'.$id ['server_name'].'</option>';
					}
		
		echo 	'</select>
			</div>
		</div>
		<div class="col-sm-3">
			<div class="col-xs-12"><label>'.$l['vdf_vpsid'].'</label></div>
			<div class="col-xs-12"><input class="form-control" type="text" name="s_vpsid" id="s_vpsuuid" size="15" value="'.REQval('s_vpsid','').'"/></div>
		</div>
		<div class="col-sm-3">
			<div class="col-xs-12"><label>'.$l['vdf_proto'].'</label></div>
			<div class="col-xs-12">
				<select name="s_protocol" id="s_protocol" class="custom-select">
					<option value="-1" '.(REQval('s_protocol') == - 1 ? 'selected="selected"' : '').'>'.$l['vdf_sel_proto'].'</option>';
					foreach($supported_protocols as $key => $id) {
						echo '<option value="'.$id.'" '.(isset($_REQUEST ['s_protocol']) && REQval('s_protocol') == $id ? 'selected="selected"' : '').'>'.$id.'</option>';
					}
		
		echo 	'</select>
			</div>
		</div>
  	</div>
  	<div class="row mx-auto w-100">
		<div class="col-sm-3">
			<div class="col-xs-12"><label>'.$l['vdf_src_hname'].'</label></div>
			<div class="col-xs-12"><input type="text" class="form-control" name="s_src_hostname" id="s_src_hostname" size="25" value="'.REQval('s_src_hostname','').'"/></div>
		</div>
		<div class="col-sm-3">
			<div class="col-xs-12"><label>'.$l['vdf_src_port'].'</label></div>
			<div class="col-xs-12"><input type="number" class="form-control" name="s_src_port" id="s_src_port" size="25" value="'.REQval('s_src_port','').'"/></div>
		</div>
		<div class="col-sm-3">
			<div class="col-xs-12"><label>'.$l['vdf_dest_ip'].'</label></div>
			<div class="col-xs-12"><input type="text" class="form-control" name="s_dest_ip" id="s_dest_ip" size="25" value="'.REQval('s_dest_ip','').'"/></div>
		</div>
		<div class="col-sm-3">
			<div class="col-xs-12"><label>'.$l['vdf_dest_port'].'</label></div>
			<div class="col-xs-12"><input type="number" class="form-control" name="s_dest_port" id="s_dest_port" size="25" value="'.REQval('s_dest_port','').'"/></div>
		</div>
  	</div>
	<div class="row mx-auto w-100 my-2">
		<div class="col-sm-12 text-center"><button type="submit" name="haproxysearch" class="go_btn" value="1"/>'.$l['search'].'</button></div>
	</div>
</div>
</form>		
</div>';
//-------------- Search VDF Block Ends ---------------------
error_handle($error);
if(!empty($done)){
	show_alert($l['done']);
}
echo '<script>
</script>';
echo '<div class="row mx-auto w-100 mb-3"><div class="col-sm-12 text-right"><button id="showvdfformbtn" class="btn text-center" onclick="showvdfform();">'.$l['new'].'</button></div></div>';
echo '
	<div class="mx-auto w-100" id="addvdf_form_div" style="display: none;">
		<div class="row title"><div class="col-xs-12">'.$l['vdf_add_title'].'</div></div>
		<form name="addvdf" id="addvdf" method="post" action="" onsubmit="return false;">
			<div class="row mx-auto w-100 my-3">
				<div class="col-sm-3">
					<label class="control-label" for="serid">'.$l['vdf_serid'].'</label>
					<select class="virt-select" id="serid" name="serid" onchange="processaddvdfform(this)" ></select>
				</div>
				<div class="col-sm-3">
					<label class="control-label" for="vpsuuid">'.$l['vdf_vpsid'].'</label>
					<select class="virt-select" id="vpsuuid" name="vpsuuid" onchange="processaddvdfform(this)" ></select>
				</div>
				<div class="col-sm-3">
					<label class="control-label" for="protocol">'.$l['vdf_proto'].'</label>
					<select class="virt-select" id="protocol" name="protocol" onchange="processaddvdfform(this)" ></select>
				</div>
				<div class="col-sm-3">
					<label class="control-label" for="src_hostname">'.$l['vdf_src_hname'].'</label>
					<input type="text" class="form-control" id="src_hostname" name="src_hostname" />
				</div>
			</div>
			<div class="row mx-auto w-100 my-3">
				<div class="col-sm-3">
					<label class="control-label" for="src_port">'.$l['vdf_src_port'].'</label>
					<input type="number" min="0" class="form-control" id="src_port" name="src_port" />
				</div>
				<div class="col-sm-3">
					<label class="control-label" for="dest_ip">'.$l['vdf_dest_ip'].'</label>
					<select class="virt-select" id="dest_ip" name="dest_ip" ></select>
				</div>
				<div class="col-sm-3">
					<label class="control-label" for="dest_port">'.$l['vdf_dest_port'].'</label>
					<input type="number" min="0" class="form-control" id="dest_port" name="dest_port" />
				</div>
			</div>
			<div class="row text-center my-2">
				<button id="submitaddvdf" onclick="processaddvdfform(this);" class="btn text-center m-2" name="submitaddvdf" >'.$l['add'].'</button> 
				<button class="btn text-center m-2" onclick=\'$("#addvdf_form_div").css("display", "none"); $("#showvdfformbtn").parents().eq(1).show();\'>'.$l['close'].'</button>
				<input type="hidden" value="addvdf" name="action" />
			</div>	
		</form>
	</div>
	';
	echo'
	<div id="domain_forwarders_div">
		<div class="row mx-auto w-100 mt-3">
			<div class="col-sm-8 col-lg-8 col-md-6 mb-3 p-0">';
				page_links($globals['num_res'], $globals['cur_page'], $globals['reslen']);
			echo'
			</div>
			<div class="col-sm-4 col-lg-4 col-md-6 text-right mb-3">
				<div class="bottom-menu float-right w-100">
					<div class="row my-auto">
						<div class="p-0">
							<label>'.$l['with_selected'].'</label>
						</div>
						<div class="col p-0">
							<select name="haproxy_multis" id="haproxy_multiselect_action_1" class="custom-select">
								<option value="0">---</option>
								<option value="1">'.$l['delete'].'</option>
							</select>
						</div>
						<div class="pl-2">
							<input type="submit" id ="haproxy_task_submit" class="go_btn" name="haproxy_task_submit" value="'.$l['go'].'" onclick="vdf_confirm(0 ,1);">
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="w-100 sticky">
		'.get_num_records($globals['num_res']).'
		<table class="table table-hover tablesorter" id="vps_forwarders_tbl">
			<thead>
				<tr>
					<th class="min_width">'.$l['id'].'</th>
					<th>'.$l['vdf_vpsid'].'</th>
					<th>'.$l['vdf_serid'].'</th>
					<th>'.$l['vdf_proto'].'</th>
					<th>'.$l['vdf_src_hname'].'</th>
					<th width="80">'.$l['vdf_src_port'].'</th>
					<th>'.$l['vdf_dest_ip'].'</th>
					<th width="30">'.$l['vdf_dest_port'].'</th>
					<th width="100px">'.$l['actions'].'</th>
					<th class="min_width z-index-1">
						'.get_checkbox('select_all', '', 'select_all', array('chk_it' => 0), '', 'select_all').'
					</th>
				</tr>
			</thead>
			<tbody>';
			foreach($haproxydata as $k => $v){
				echo '<tr class="text-center">
				<td><span id="'.$k.'_id"><span class="coldat">'.$v['id'].'</span></span></td>
				<td><span id="'.$k.'_vpsuuid"><span class="coldat">'.$v['vpsid'].' ('.$v['hostname'].')'.'</span></span></td>
				<td><span id="'.$k.'_serid"><span class="coldat">'.$servers[$v['serid']]['server_name'].'</span></span></td>
				<td><span id="'.$k.'_protocol"><span class="coldat">'.$v['protocol'].'</span></span></td>
				<td><span id="'.$k.'_src_hostname"><span class="coldat">'.$v['src_hostname'].'</span></span></td>
				<td><span id="'.$k.'_src_port"><span class="coldat">'.$v['src_port'].'</span></span></td>
				<td><span id="'.$k.'_dest_ip"><span class="coldat">'.$v['dest_ip'].'</span></span></td>
				<td><span id="'.$k.'_dest_port"><span class="coldat">'.$v['dest_port'].'</span></span></td>
				<td><span class="vdf_actions" id="'.$v['id'].'_vdf_actions"><span class="vdf_edit" id="'.$v['id'].'_edit"><i class="fa fa-edit" onclick="edit_row(this, '.$v['id'].')" tooltip="'.$l['vdf_tooltip_edit'].'"></i></span><span class="vdf_delete"><i class="fa fa-trash" onclick="vdf_confirm('.$v['id'].');" tooltip="'.$l['vdf_tooltip_delete'].'" ></i></span></span></td>
				<td>
					<span id="'.$v['id'].'_checkbox">
						'.get_checkbox('vdf_list[]', '', '', array('chk_it' => 0), $v['id']).'
					</span>
				</td>
				</tr>';
			}
			echo '
			</tbody>
			<tfoot></tfoot>
		</table>
		</div>';
		echo'<div class="row mx-auto w-100 mt-5">
			<div class="col-sm-8 col-lg-8 col-md-6 mb-3 p-0">';
				page_links($globals['num_res'], $globals['cur_page'], $globals['reslen']);
			echo'
			</div>
			<div class="col-sm-4 col-lg-4 col-md-6 text-right mb-3">
				<div class="bottom-menu float-right w-100">
					<div class="row my-auto">
						<div class="p-0">
							<label>'.$l['with_selected'].'</label>
						</div>
						<div class="col p-0">
							<select name="haproxy_multis" id="haproxy_multiselect_action_2" class="custom-select">
								<option value="0">---</option>
								<option value="1">'.$l['delete'].'</option>
							</select>
						</div>
						<div class="pl-2">
							<input type="submit" id ="haproxy_task_submit" class="go_btn" name="haproxy_task_submit" value="'.$l['go'].'" onclick="vdf_confirm(0 ,2);">
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
		<div id="haservers_div" class="overflow-auto">
		</div>
		</div>
			
	</div>
	
';
echo '</div>'; // End of BG html class
softfooter();
echo '
<div id="processing_symb"><div class="loader-lg"></div></div>
';
}

?>